from visual import *


scene.width = 1000
scene.height = 800
scene.x = scene.y = 0
scene = display(forward = (0,-9,0))
scene.fullscreen = true
background = (1,0.5,0)
xmax = .5
dx = xmax/5.
grid = []
for x in arange(-xmax, xmax+dx, dx):
    grid.append(curve(pos=[(x,0,-xmax),(x,0,xmax)], color=color.blue))
for z in arange(-xmax, xmax+dx, dx):
    grid.append(curve(pos=[(-xmax,0,z),(xmax,0,z)],color=color.blue))

## initialize lambda 
lamb = sphere(pos=vector(0,0,0.5), color=(1,0,1), radius = dx/8.)
lamb.mass = 1.85e-27
## initial momentum
lamb.p = lamb.mass*vector(0,0,-3e7)
lamb.charge = 0
lamb.trail = curve(color=lamb.color)
Farrow = arrow(pos=lamb.pos, axis=(0,0,0), color=color.cyan)
Fscale = 1.e11
Varrow = arrow(pos=lamb.pos, axis=(0,0,0), color=color.green)
Vscale = 1e-8

E0 = vector(10000000,0,0)


deltat = (xmax/(mag(lamb.p)/lamb.mass))/2000

t = 800

## when the lambda gets to (0,0,0) make it decay
while lamb.z > 0:
   
    v = lamb.p / lamb.mass
    F = lamb.charge*E0
    lamb.p = lamb.p + F*deltat
    lamb.pos = lamb.pos + (lamb.p/lamb.mass)*deltat

    lamb.trail.append(pos=lamb.pos)
    rate(t)

lamb.visible = false

## initialize first decay particle
decayA = sphere(pos=lamb.pos, color=(0,5,0), radius = dx/8.)
decayA.trail = curve(color=decayA.color)
decayA.mass = 2.5e-28
## velocity scaled based on mass to conserve momentum
decayA.p = decayA.mass*v/8
decayA.charge = -1.6e-19

## initialize second decay particle
decayB = sphere(pos=lamb.pos, color=(0,0,5), radius = dx/8.)
decayB.trail = curve(color=decayB.color)
decayB.mass = 1.7e-27
## velocity scaled based on mass to conserve momentum
decayB.p = decayB.mass*v*7/8 
decayB.charge = 1.6e-19

## have the particles travel until one reaches the edge of the grid
while decayA.z > -0.5:
   
    velA = decayA.p / decayA.mass
    FA = decayA.charge*E0
    decayA.p = decayA.p + FA*deltat
    decayA.pos = decayA.pos + (decayA.p/decayA.mass)*deltat

    decayA.trail.append(pos=decayA.pos)
    rate(t)

    velB = decayB.p / decayB.mass
    FB = decayB.charge*E0
    decayB.p = decayB.p + FB*deltat
    decayB.pos = decayB.pos + (decayB.p/decayB.mass)*deltat


    decayB.trail.append(pos=decayB.pos)
    rate(t)
##check to see if decay particle reaches edge of grid 
    if decayA.x>xmax or decayB.x>xmax or decayA.x<-xmax or decayB.x<-xmax or decayA.z<-xmax or decayB.z<-xmax or decayA.z<-xmax or decayB.z<-xmax:
        break
